#!/usr/bin/ruby
#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2015-2016 Michael Uplawski <michael.uplawski@uplawski.eu>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************
=end

require_relative 'logging'
require_relative 'argparser'
require_relative 'user_input'

=begin
	Shows a text-file line by line
=end
class LineByLine
	include Logging

	def initialize(args)
		init_logger()
		if(args.empty?)
			@log.warn("\n\n\tNo Arguments!\n")
			@log.info("Call with option \"-h\" to see some options\n")
			exit true
		end
		options = ArgParser::parse(args)

		# file = args[0]
		file = options.file 
		advance = options.line

		@log.debug('file is ' << file.to_s)
		if(file && File::exist?(file) && File::readable?(file))
			f = File.open(file)
			system('clear')
			until f.eof
				c = nil
				begin 
					until(advance == 0 || f.eof) do
						f.readline
						advance -= 1
					end
					line = ''
					loop do 
						line = f.readline
						if(options.fast )
							print line
						else
							char_by_char line
						end
						last_char = line.strip[-1]
						@log.debug 'last char of |' << line.strip << '| is ' << (last_char ? last_char : 'N I L')
						break unless ('↵' == last_char || '\\' == last_char )
					end
					unless "\n" == line
						c = wait_for_user
					end
				rescue Interrupt
					@log.info("\n\n\tprogram interrupted by user")
					exit true
				end
				# key 'f'
				if(102 == c)
					options.fast = true
					# key 's'
				elsif(115 == c)
					options.fast = false
					# keys ctrl+c, ctrl+d, 'q'
				elsif(4 == c || 3 == c || 113 == c)
					exit true
				end
			end
		else
			@log.error("File %s is unsuitable as input to %s"%[file, $0])
		end
	end

	private
	def char_by_char(line)
		line.split('').each do |c| 
			if ('↵' != c && '\\' != c)
				@log.debug('printing ' << c)
				print c; 
				sleep 0.1 
			end
		end
	end
	def usage
		usage = %~    Usage: %s [text-file]~ %$0
		print usage
	end
end

if $0 == __FILE__
LineByLine.new(ARGV)
	end
